<template>
  <div
    class="group-body"
    :class="{opened : isOpened, single: !isGroup}">
    <div
      class="group-title"
      @click="rowClick">
      <div class="row body">
        <slot name="title">
          <div class="row w-0">
            <div
              v-if="number"
              class="number">{{ number }}.&nbsp;</div>
            <div class="item name">{{ rowName }}</div>
          </div>

          <div
            v-if="struct.col1"
            class="row w-1">
            <div
              v-for="structItem in struct.col1.items"
              :key="structItem.key"
              class="item">
              {{ item.row[structItem.key] }}
            </div>
          </div>

          <div
            v-if="struct.col2"
            class="row w-2">
            <div
              v-for="structItem in struct.col2.items"
              :key="structItem.key"
              class="item">
              {{ item.row[structItem.key] }}
            </div>
          </div>

          <div
            v-if="struct.col3"
            class="row w-3">
            <div
              v-for="(structItem, index) in struct.col3.items"
              :key="structItem.key"
              class="item"
              :class="{ 'w-4': index === struct.col3.items.length - 1 }">
              {{ item.row[structItem.key] }}
            </div>
          </div>
        </slot>
      </div>
    </div>
    <div
      class="group-content"
      v-if="isGroup">
      <slot name="content"/>
    </div>
  </div>
</template>

<script>
import { get } from 'lodash-es';

export default {
  name: 'GroupBody',
  props: {
    item: {
      type: Object,
      required: true,
    },
    group: {
      type: String,
      default: null,
    },
    struct: {
      type: Object,
      required: true,
    },
    number: {
      type: Number,
      default: null,
    },
  },
  data() {
    return {
      isOpened: false,
    };
  },
  computed: {
    isGroup() {
      return this.item.data;
    },
    rowName() {
      const groupName = get(this.item.row, 'group.name', false);
      if (groupName) {
        return groupName;
      }
      switch (this.group) {
        case 'ENGINE': return 'Двигатель не указан';
        case 'CHASSIS': return 'Кузов не указан';
        case 'YEAR': return 'Год не указан';
        default: return 'Прямой переход';
      }
    },
  },
  methods: {
    rowClick() {
      this.isOpened = !this.isOpened;
      if (this.isOpened && this.item.data !== null && this.item.data.loaded === undefined) {
        this.$emit('try-load', this.item);
      }
    },
  },
};
</script>

<style scoped lang="scss">
  @import "~/assets/scss/modules/_table-statistics.scss";
</style>
